<?php

namespace Teknisa\TCO\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource;

class TcoDadosTipoPratoController extends \Teknisa\GER\Controllers\TeknisaCrud {
    
    protected $crudService;

    public function __construct($crudService, $parameterBag) {
        $this->crudService           = $crudService;
    }
    

   public function retornaTipoPratoGrupo(DTO\Request\Filter $request, DTO\Response $response) {
        $dataSourceName = str_replace('/', '', $request->getRoutePath());
        $newRows = [];
        
        $conditions = $request->getFilterCriteria()->getConditions();
        $dataSet = $this->crudService->getFilteredDataSet($dataSourceName, $conditions);
        $rows = $dataSet->getRows();
        $mappedIndexLastItemGroup = [];
        $newRows = $dataSet->getRows();
        if(isset($rows) && !empty($rows)){
            foreach($rows as $index => $row){
                $curGroup = $row['CDGRTIPOPR'];
                if(isset($mappedIndexLastItemGroup[$curGroup])) {
                    $lastIndex = $mappedIndexLastItemGroup[$curGroup];
                    if($lastIndex !== $index-1) {
                        array_splice($newRows, $index, 1); // remove current item
                        array_splice($newRows, $lastIndex+1, 0, [$row]); // add currentItem in correct position
                        foreach($mappedIndexLastItemGroup as $key => $curIndex){
                            if($curIndex >= $lastIndex){
                                $mappedIndexLastItemGroup[$key]++;
                            }
                        }
                    } else {
                        $mappedIndexLastItemGroup[$curGroup] = $index;
                    }
                } else {
                    $mappedIndexLastItemGroup[$curGroup] = $index;
                }
            }
        }
        $response->addDataSet(new DataSet($dataSourceName, $newRows));
    }

    
}
